
#include "mocktcp.h"

#define SIZE 		20000
#define INTERVAL 	3
#define NUM 		7
#define LOOP 		1000000

int	flag = FALSE;

void handler(int s)
{
	flag = TRUE;
}

main(int argc, char** argv)
{
	int	s, port, res, i, sock;
	int	socks[NUM];
	int	counts[NUM];
	char	buf[SIZE];
	fd_set	fds;
	struct sockaddr_in client;
	struct itimerval t;
	struct timeval	val = {INTERVAL, 0};

	if (argc != 2) {
		fprintf(stderr, "usage: server {port}\n");
		exit(1);
	}
	port  = atoi(argv[1]);

	fprintf(stderr, "Server waiting on port %d.\n", port);

	s = mt_socket();
	if (s < 0) {
		perror("mt_socket");
		exit(1);
	}

	res = mt_bind(s, port);
	if (res < 0) {
		perror("mt_bind");
		exit(1);
	}

	fprintf(stderr, "Accepting...\n");
	for (i=0; i < NUM; i++) {
		socks[i] = mt_accept(s, &client);
		if (socks[i] < 0) {
			perror("mt_accept");
			exit(1);
		}
	}

	fprintf(stderr, "New connections established.\n");

	for (i=0; i < NUM; i++)
		counts[i] = 0;

	for (;;) {
		FD_ZERO(&fds);
		for (i=0; i < NUM; i++) {
			if (socks[i] == -1) continue;
			FD_SET(socks[i], &fds);
		}
		/*
		fprintf(stderr, "About to mt_select...\n");
		*/
		retry:
		res = mt_select(256, &fds, NULL, NULL, NULL);
		if (res < 0) {
			if (errno == EINTR) goto retry;
			perror("mt_select");
			exit(1);
		}
		for (i=0; i < NUM; i++) {
			if (socks[i] == -1)
				continue;
			if (!FD_ISSET(socks[i], &fds))
				continue;
			/*
			fprintf(stderr, "About to mt_read...\n");
			*/
			res = mt_read(socks[i], buf, SIZE);
			if (res < 0) {
				perror("mt_read");
				exit(1);
			}

			if (res == 0) {
				fprintf(stderr, "closing connection %d\n", i);
				res = mt_close(socks[i]);
				if (res < 0) {
					perror("mt_close");
					exit(1);
				}
				socks[i] = -1;
				fprintf(stderr, "done closing.\n");
				continue;
			}

			counts[i] += res;

			res = mt_write(socks[i], buf, res);
			if (res < 0) {
				perror("mt_read");
				exit(1);
			}

			/* generate some output */
			if (counts[i] > LOOP) {
				int	j;

				for (j=-1; j < i; j++)
					fprintf(stderr, "\t");
				fprintf(stderr, ".\n");
				counts[i] = 0;
			}
		}
	}
}


