/*
 * A very simple test program that uses DC.
 * When run the first time, it will get part way, then exit(1) to simulate
 * a crash.  When run the second time, it will recover from the most recent
 * checkpoint, then continue the run.  It continues instead of re-calling
 * exit(1) by clearing flag in the user-defined recovery function (recov()).
 * After the second time, it will use dc_exit to delete the checkpoint and
 * exit.
 */
#include <stdio.h>
#include "../include/dc.h"

int heapNum = 10;

int flag=0;

void recov()
{
    fprintf(stderr, "my recovery function\n");
    flag = 1;
}

main(int argc, char *argv[])
{
    int i, j;
    char *buf;

    dc_init("testdc", NULL, recov, &argv, NULL);

    i = 2;
    fprintf(stderr, "i=%d, &i=0x%lx, heapNum=%d\n", i, &i, heapNum);

    buf = (char *) malloc(1024*1024);
    if (buf == NULL) {
	perror("malloc");
	exit(1);
    }

    fprintf(stderr, "buf=0x%lx\n", buf);
    for (j=0; j<5; j++) {
	buf[j] = j;
    }
    for (j=0; j<5; j++) {
	fprintf(stderr, "buf[%d]=%d\n", j, buf[j]);
    }

    dc_checkpoint();

    heapNum = 1;

    /*
    for (i=0; i<100; i++) {
	dc_checkpoint();
    }
    */

    fprintf(stderr, "returned from dc_checkpoint() to main()\n");

    for (j=0; j<5; j++) {
	fprintf(stderr, "buf[%d]=%d\n", j, buf[j]);
    }

    /*
     * This is where the program exits the first time.
     */
    if (!flag) {
	exit(1);
    }
    fprintf(stderr, "i=%d, &i=0x%lx, heapNum=%d\n", i, &i, heapNum);
    for (j=0; j<5; j++) {
	buf[j] = j*2;
    }
    for (j=0; j<5; j++) {
	fprintf(stderr, "buf[%d]=%d\n", j, buf[j]);
    }
    free(buf);
    dc_exit(2);
}
